ForceFieldUFF
Date: 2019-10-22

org.jmol.minimize.forcefield

## Class ForceFieldUFF

- java.lang.Object
- - org.jmol.minimize.forcefield.ForceField
  - - org.jmol.minimize.forcefield.ForceFieldUFF

-     public class ForceFieldUFF
      extends ForceField

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static javajs.util.Lst<java.lang.String[]>` | `atomTypes`
    `private javajs.util.BS` | `bsAromatic`
    `private static java.util.Map<java.lang.Object,java.lang.Object>` | `ffParams`
    `private static int` | `PT_CHARGE`
    `private static int` | `PT_CONNECT`
    `private static int` | `PT_ELEMENT`
    `private static int` | `TOKEN_AROMATIC`
    `private static int` | `TOKEN_ELEMENT_ALLYLIC`
    `private static int` | `TOKEN_ELEMENT_CHARGED`
    `private static int` | `TOKEN_ELEMENT_CONNECTED`
    `private static int` | `TOKEN_ELEMENT_ONLY`
    `private static int` | `TOKEN_ELEMENT_SP`
    `private static T[][]` | `tokenTypes`

    - ### Fields inherited from class org.jmol.minimize.forcefield.ForceField

      `ABI_IJ, ABI_JK, bsFixed, calc, currentStep, EANGLE, EBOND, EELECTROSTATIC, ENERGY, EOOP, ESTRBND, ETORSION, EVDW, minAngles, minAtomCount, minAtoms, minBondCount, minBonds, minimizer, minPositions, minTorsions, name, R3, R4, R5, Raromatic, TBI_AB, TBI_BC, TBI_CD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ForceFieldUFF(Minimizer minimizer)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()`
    `private javajs.util.Lst<java.lang.String[]>` | `getAtomTypes()`
    `private java.util.Map<java.lang.Object,java.lang.Object>` | `getFFParameters()`
    `private javajs.util.BS` | `getSearch(java.lang.String smarts, int elemnoMax, javajs.util.BS bsElements)`
    `private void` | `setAtomTypes(javajs.util.BS bsElements, int elemnoMax)`
    `boolean` | `setModel(javajs.util.BS bsElements, int elemnoMax)`

    - ### Methods inherited from class org.jmol.minimize.forcefield.ForceField

      `detectExplosion, energyAngle, energyBond, energyES, energyFull, energyOOP, energyStretchBend, energyTorsion, energyVDW, getAtomList, getBufferedReader, getCurrentStep, getEnergy, getEnergyDiff, getLogData, getNormalizedDE, log, setConstraints, setModelFields, steepestDescentInitialize, steepestDescentTakeNSteps, toUserUnits`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### atomTypes

          private static javajs.util.Lst<java.lang.String[]> atomTypes

    - #### ffParams

          private static java.util.Map<java.lang.Object,java.lang.Object> ffParams

    - #### bsAromatic

          private javajs.util.BS bsAromatic

    - #### TOKEN_ELEMENT_ONLY

          private static final int TOKEN_ELEMENT_ONLY

      See Also:
        Constant Field Values

    - #### TOKEN_ELEMENT_CHARGED

          private static final int TOKEN_ELEMENT_CHARGED

      See Also:
        Constant Field Values

    - #### TOKEN_ELEMENT_CONNECTED

          private static final int TOKEN_ELEMENT_CONNECTED

      See Also:
        Constant Field Values

    - #### TOKEN_AROMATIC

          private static final int TOKEN_AROMATIC

      See Also:
        Constant Field Values

    - #### TOKEN_ELEMENT_SP

          private static final int TOKEN_ELEMENT_SP

      See Also:
        Constant Field Values

    - #### TOKEN_ELEMENT_ALLYLIC

          private static final int TOKEN_ELEMENT_ALLYLIC

      See Also:
        Constant Field Values

    - #### PT_ELEMENT

          private static final int PT_ELEMENT

      See Also:
        Constant Field Values

    - #### PT_CHARGE

          private static final int PT_CHARGE

      See Also:
        Constant Field Values

    - #### PT_CONNECT

          private static final int PT_CONNECT

      See Also:
        Constant Field Values

    - #### tokenTypes

          private static final T[][] tokenTypes

  - ### Constructor Detail

    - #### ForceFieldUFF

          public ForceFieldUFF(Minimizer minimizer)

  - ### Method Detail

    - #### clear

          public void clear()

      Specified by:
        `clear` in class `ForceField`

    - #### setModel

          public boolean setModel(javajs.util.BS bsElements,
                                  int elemnoMax)
                           throws JmolAsyncException

      Specified by:
        `setModel` in class `ForceField`
      Throws:
        `JmolAsyncException`

    - #### setAtomTypes

          private void setAtomTypes(javajs.util.BS bsElements,
                                    int elemnoMax)

    - #### getSearch

          private javajs.util.BS getSearch(java.lang.String smarts,
                                           int elemnoMax,
                                           javajs.util.BS bsElements)

    - #### getFFParameters

          private java.util.Map<java.lang.Object,java.lang.Object> getFFParameters()

    - #### getAtomTypes

          private javajs.util.Lst<java.lang.String[]> getAtomTypes()
                                                            throws JmolAsyncException

      Throws:
        `JmolAsyncException`